<?php
/*
Plugin Name: oupsmangallery
Plugin URI: http://oupsman.fr/
Description: Gallery on one line, scrolable and windowed
Version: 0.5
Author: Benoit SERRA
Author URI: http://oupsman.fr/gallery
*/


remove_shortcode('gallery');
add_shortcode('gallery', 'parse_gallery_shortcode');
//add_action( 'wp_enqueue_scripts', 'oupsmangallery_wp_head' );

// Add required thumbnails size
add_image_size ('oupsmangallery_size',900,600,false);

function oupsmangallery_wp_head () {

    // Enqueue the required stylesheet for this plugin

    wp_enqueue_style( 'oupsmangallery_stylesheet', plugins_url( 'css/oupsmangallery.css', __FILE__ ) );

    // Enqueue the good version of jQuery and all the required plugins

    wp_enqueue_script ('oupsmangallery_jQuery', plugins_url ('js/jQuery-1.9.1.js', __FILE__ ) );
    wp_enqueue_script ('oupsmangallery_hoverintent', plugins_url ('js/jquery.hoverintent.min.js', __FILE__ ) );
    wp_enqueue_script ('oupsmangallery_jscrollpane', plugins_url ('js/jquery.jscrollpane.min.js', __FILE__ ) );
    wp_enqueue_script ('oupsmangallery_jscrollpane_mw', plugins_url ('js/jquery.jscrollpane.mousewheel.js', __FILE__ ) );

    // Try to enqueue the customised script for the page but it doesn't work for now
    // TODO : find the right hook for this script

    wp_enqueue_script ('oupsmangallery_js', plugins_url ('js/oupsmangallery.js', __FILE__ ) );

}

function parse_gallery_shortcode($atts) {
 
    global $post;

    // Zeroing the result variable

    $result ="";

    if ( ! empty( $atts['ids'] ) ) {
        // 'ids' is explicitly ordered, unless you specify otherwise.
        if ( empty( $atts['orderby'] ) )
            $atts['orderby'] = 'post__in';
        $atts['include'] = $atts['ids'];
    }
 
    extract(shortcode_atts(array(
        'orderby' => 'menu_order ASC, ID ASC',
        'include' => '',
        'id' => $post->ID,
        'itemtag' => 'dl',
        'icontag' => 'dt',
        'captiontag' => 'dd',
        'columns' => 3,
        'size' => 'medium',
        'link' => 'file'
    ), $atts));
 
 
    $args = array(
        'post_type' => 'attachment',
        'post_status' => 'inherit',
        'post_mime_type' => 'image',
        'orderby' => $orderby
    );
 
    if ( !empty($include) ) {
        $args['include'] = $include;
    } else {
        $args['post_parent'] = $id;
        $args['numberposts'] = -1;
    }
 
    $images = get_posts($args);

    $result .= "\n<!-- oupsmangallery plugin -->\n";

    // Enqueue the required stylesheet for this plugin

    wp_enqueue_style( 'oupsmangallery_stylesheet', plugins_url( 'css/oupsmangallery.css', __FILE__ ) );

    // Enqueue the good version of jQuery and all the required plugins

    wp_enqueue_script ('oupsmangallery_jQuery', plugins_url ('js/jQuery-1.9.1.js', __FILE__ ) );
    wp_enqueue_script ('oupsmangallery_hoverintent', plugins_url ('js/jquery.hoverintent.min.js', __FILE__ ) );
    wp_enqueue_script ('oupsmangallery_jscrollpane', plugins_url ('js/jquery.jscrollpane.min.js', __FILE__ ) );

    // Try to enqueue the customised script for the page but it doesn't work for now
    // TODO : find the right hook for this script


    $result .= "<p class='explain'>Vous pouvez faire défiler la galerie avec les flèches gauche et droite du clavier. En positionnant le curseur de votre souris sur une image, la légende apparaitra</p>\n";

    $result .= "<div id='oupsmangallery'>\n";
    $result .= "<table id='gallery'><tbody><tr>\n";


    foreach ( $images as $image ) {

	    $conv = htmlentities($image->post_excerpt, ENT_QUOTES);
	    $description = str_replace("&lt;br&gt;",'<br>',$conv);

        $image_alt = get_post_meta($image->ID,'_wp_attachment_image_alt', true);

        $result .= '<td class="galleryelement">';

        if ($description != "" ) {
            $result .= '<div class="darkenjquery">'."\n";
        } else {
            $result .= '<div class="nolegend">';

        }

        $image_src = wp_get_attachment_image_src ($image->ID, array(750,500));

        $result .= '<img class="galleryimage" src="' . $image_src[0] . '" alt="'. $image_alt . '">';

        $result .= '<span class="legend">' . $description . '</span>';

        $result .= "</div></td>\n";

    }

    $result .= "</tr></tbody></table>\n";
    $result .= "</div>\n";

    wp_enqueue_script ('oupsmangallery_js', plugins_url ('js/oupsmangallery.js', __FILE__ ) );


    return $result;
}
?>
